import java.awt.*;
import javax.swing.*;
import java.io.*;

class PaulCallahanRule extends Rule
{
  public PaulCallahanRule(JFrame mainFrame, HexagonalCell hexagonalCell)
  {
    super(mainFrame, hexagonalCell);
    this.mainFrame = mainFrame;
    this.hexagonalCell = hexagonalCell;
  }

  public void setNewRule()
  {
  }

  public void setOptions()
  {
  }

  public void setDefault()
  {
  }

  public void changeRule()
  {
  }

  public void writeRule(PrintWriter pw)
  {
    pw.println("#Rule = Paul Callahan Rule");
  }

  public void readRule(BufferedReader br)
  {
  }

  public int step(int column, int row)
  {
    int neighbors[] = new int[6];
    if ((row % 2) == 0)
    {
      neighbors[0] = hexagonalCell.getCell(column - 1, row - 1);
      neighbors[1] = hexagonalCell.getCell(column    , row - 1);
      neighbors[2] = hexagonalCell.getCell(column + 1, row    );
      neighbors[3] = hexagonalCell.getCell(column    , row + 1);
      neighbors[4] = hexagonalCell.getCell(column - 1, row + 1);
      neighbors[5] = hexagonalCell.getCell(column - 1, row    );
    }
    else
    {
      neighbors[0] = hexagonalCell.getCell(column    , row - 1);
      neighbors[1] = hexagonalCell.getCell(column + 1, row - 1);
      neighbors[2] = hexagonalCell.getCell(column + 1, row    );
      neighbors[3] = hexagonalCell.getCell(column + 1, row + 1);
      neighbors[4] = hexagonalCell.getCell(column    , row + 1);
      neighbors[5] = hexagonalCell.getCell(column - 1, row    );
    }
    int cell = hexagonalCell.getCell(column, row);
    int n = 0;
    for (int i = 5; i >= 0; i--)
      n += (neighbors[i] << i); 
    int sum = 0;
    for (int i = 0; i < 6; i++)
      if (neighbors[i] == 1)
        sum++;
    if (sum == 2)
    {
      if ((cell == 0) && ((n == 3) || (n == 6) || (n == 12) || (n == 24) || (n == 48) || (n == 33)))
        return 1;
      else if ((n == 5) || (n == 10) || (n == 20) || (n == 40) || (n == 17) || (n == 34))
        return cell;
    }
    else if ((sum == 3) || (sum == 4))
      return cell;
    return 0;
  }

  public int getNoStates()
  {
    return 2;
  }
}
