import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;


class WeightsGrid extends JPanel
{
  private GridSpinner grid[][];

  public WeightsGrid(int rows, int columns, Border border, String title, String[][] labels, int minimum, int maximum)
  {
    JPanel gridPanel = new JPanel();
    gridPanel.setLayout(new GridLayout(rows, columns));
    grid = new GridSpinner[rows][columns];
    for (int r = 0; r < rows; r++)
      for (int c = 0; c < columns; c++)
      {
        grid[r][c] = new GridSpinner(70, 20, labels[r][c], 0, minimum, maximum, false);
        gridPanel.add(grid[r][c]);
      }
    setBorder(BorderFactory.createTitledBorder(border, title));
    add(gridPanel);
  }

  public int getValue(int r, int c)
  {
    return grid[r][c].getValue();
  }

  public void setValue(int r, int c, int value)
  {
    grid[r][c].setValue(value);
  }
}
